//
//  MyView.swift
//  events
//
//  Created by David Eyers on 13/09/15.
//  Copyright (c) 2015 David Eyers. All rights reserved.
//

import Cocoa

class MyView: NSView {

    override var acceptsFirstResponder: Bool { return true; }
    override func resignFirstResponder()->Bool { return true; }
    
    override func draw(_ dirtyRect: NSRect) {
        NSColor.blue.setFill()
        NSRectFill(dirtyRect)
        super.draw(dirtyRect)
    }

    override func mouseDown(with theEvent: NSEvent) {
        let p = theEvent.locationInWindow
        Swift.print("mouseDown in \(self.className) at \(p)")
        nextResponder?.mouseDown(with: theEvent)
    }
    
    override func keyDown(with theEvent: NSEvent) {
        let flags:Int = Int(theEvent.modifierFlags.rawValue)
        let mask:Int = flags & Int(NSEventModifierFlags.control.rawValue)
        if(mask != 0){
            self.nextResponder?.keyDown(with: theEvent)
        }else{
            Swift.print("'\(theEvent.keyCode)' keyDown in '\(self.className)'")
        }
    }
}
